<?php if (!defined('ABSPATH')) {exit;}
/**
* Traits Age for simple products
*
* @author		Maxim Glazunov
* @link			https://icopydoc.ru/
* @since		1.6.0
*
* @return 		$result_xml (string)
*
* @depends		class:		XFAVI_Get_Paired_Tag
*				methods: 	get_product
*							get_feed_id
*				functions:	xfavi_optionGET
*/

trait XFAVI_T_Simple_Get_Apparel {
	public function get_apparel($tag_name = 'Apparel', $standart = '', $result_xml = '') {
		$product = $this->get_product();

		if (get_post_meta($product->get_id(), '_xfavi_apparel', true) === '' || get_post_meta($product->get_id(), '_xfavi_apparel', true) === 'default') {
			// если в карточке товара запрет - проверяем значения по дефолту
			if (get_term_meta($this->get_feed_category_id(), 'xfavi_default_apparel', true) == '') {
				$this->add_skip_reason(array('reason' => __('Отсутствует Apparel', 'xfavi'), 'post_id' => $product->get_id(), 'file' => 'trait-xfavi-t-simple-get-apparel.php', 'line' => __LINE__)); return '';
			} else {
				$result_apparel = get_term_meta($this->get_feed_category_id(), 'xfavi_default_apparel', true);
			}
		} else {
			$result_apparel = get_post_meta($product->get_id(), '_xfavi_apparel', true);
			if ($result_apparel === 'disabled') {
				$result_apparel = '';
				// new XFAVI_Error_Log('FEED № '.$feed_id.'; Товар с postId = '.$product->get_id().' пропущен т.к отсутствует Apparel; Файл: lichnye_veshi.php; Строка: '.__LINE__); return $result_xml;
			}
		}
		if (($result_apparel == '' || $result_apparel === 'disabled')) {
			if ($standart === 'lichnye_veshi' && in_array($this->get_feed_category_avito_name(), array('Одежда, обувь, аксессуары', 'Детская одежда и обувь'))) {
				$this->add_skip_reason(array('reason' => __('Отсутствует Apparel', 'xfavi'), 'post_id' => $product->get_id(), 'file' => 'trait-xfavi-t-simple-get-apparel.php', 'line' => __LINE__)); return '';
			} else {
				$result_xml_apparel = '';
			}
		} else {
			// $result_xml_apparel = '<Apparel>'.$result_apparel.'</Apparel>'.PHP_EOL;
		}

		$result_apparel = apply_filters('xfavi_f_simple_tag_apparel', $result_apparel, array('product' => $product), $this->get_feed_id());
		$result_xml .= new XFAVI_Get_Paired_Tag($tag_name, $result_apparel);
		return $result_xml;
	}
}
?>