<?php if (!defined('ABSPATH')) {exit;}
/**
* Traits for variable products
*
* @author		Maxim Glazunov
* @link			https://icopydoc.ru/
* @since		1.6.0
*
* @return 		$result_xml (string)
*
* @depends		class:	XFAVI_Get_Paired_Tag
*				methods: add_skip_reason
*				functions: 
*/

trait XFAVI_T_Variable_Get_Adtype {
	public function get_adtype($tag_name = 'AdType', $standart = '', $result_xml = '') {
		$product = $this->product;
		$offer = $this->offer;

		// AdType
		if (get_post_meta($product->get_id(), '_xfavi_adType', true) === 'disabled') {
			$result_adType = 'disabled';
		} else if (get_post_meta($product->get_id(), '_xfavi_adType', true) == '' || get_post_meta($product->get_id(), '_xfavi_adType', true) === 'default') {
			$result_adType = get_term_meta($this->get_feed_category_id(), 'xfavi_adType', true);
			$result_adType = str_replace('_', ' ', $result_adType);
		} else {
			$result_adType = get_post_meta($product->get_id(), '_xfavi_adType', true);
		}
		if ($result_adType == '' || $result_adType == 'disabled') {		
			if ($standart !== 'zapchasti') {	
				$this->add_skip_reason(array('offer_id' => $offer->get_id(), 'reason' => __('Отсутствует AdType', 'xfavi'), 'post_id' => $product->get_id(), 'file' => 'trait-xfavi-t-variable-get-adtype.php', 'line' => __LINE__)); return '';
			}
		} else {
			// $result_xml_adType = $result_adType;
		}
		// end AdType

		$result_xml .= new XFAVI_Get_Paired_Tag($tag_name, $result_adType);
		return $result_xml; 
	}
}
?>