<?php if (!defined('ABSPATH')) {exit;}
/**
* Traits for variable products
*
* @author		Maxim Glazunov
* @link			https://icopydoc.ru/
* @since		1.6.0
*
* @return 		$result_xml (string)
*
* @depends		class:	XFAVI_Get_Paired_Tag
*				methods: add_skip_reason
*				functions: 
*/

trait XFAVI_T_Variable_Get_Goods_Type {
	public function get_goods_type($tag_name = 'GoodsType', $standart = '', $result_xml = '') {
		$product = $this->product;
		$offer = $this->offer;

		// для Охота и рыбалка в разделе хобби GoodsType не нужен
		if ($this->get_feed_category_avito_name() === 'Охота и рыбалка') {return '';}

		if (get_post_meta($product->get_id(), '_xfavi_goods_type', true) === '' || get_post_meta($product->get_id(), '_xfavi_goods_type', true) === 'default') {
			// если в карточке товара запрет - проверяем значения по дефолту
			if (get_term_meta($this->get_feed_category_id(), 'xfavi_default_goods_type', true) == '') {
				$this->add_skip_reason(array('offer_id' => $offer->get_id(), 'reason' => __('Отсутствует GoodsType', 'xfavi'), 'post_id' => $product->get_id(), 'file' => 'trait-xfavi-t-simple-get-goods-type.php', 'line' => __LINE__)); return '';
			} else {
				$xfavi_default_goods_type = get_term_meta($this->get_feed_category_id(), 'xfavi_default_goods_type', true);
				$xfavi_default_goods_type = str_replace('_', ' ', $xfavi_default_goods_type);
				if ($xfavi_default_goods_type === 'disabled') {
					$result_goods_type = '';
				} else {
					$result_goods_type = $xfavi_default_goods_type;
				}
			}
		} else {
			$result_goods_type = get_post_meta($product->get_id(), '_xfavi_goods_type', true);
			$result_goods_type = str_replace('_', ' ', $result_goods_type);
			if ($result_goods_type === 'disabled' && $standart === '') {
				$this->add_skip_reason(array('offer_id' => $offer->get_id(), 'reason' => __('Отсутствует GoodsType', 'xfavi'), 'post_id' => $product->get_id(), 'file' => 'trait-xfavi-t-simple-get-goods-type.php', 'line' => __LINE__)); return '';
			} else if ($result_goods_type === 'disabled' && $standart === 'hobby') {
				if ($this->get_feed_category_avito_name() === 'Велосипеды' || $this->get_feed_category_avito_name() === 'Охота и рыбалка') {
				} else {
					$this->add_skip_reason(array('offer_id' => $offer->get_id(), 'reason' => __('Отсутствует GoodsType', 'xfavi'), 'post_id' => $product->get_id(), 'file' => 'trait-xfavi-t-simple-get-goods-type.php', 'line' => __LINE__)); return '';
				}
			} else if ($result_goods_type === 'disabled' && $standart === 'zhivotnye') {
				if ($xfavi_avito_product_category === 'Другие животные' || $xfavi_avito_product_category === 'Кошки' || $xfavi_avito_product_category === 'Собаки') {
					$this->add_skip_reason(array('offer_id' => $offer->get_id(), 'reason' => __('Отсутствует GoodsType / Bread', 'xfavi'), 'post_id' => $product->get_id(), 'file' => 'trait-xfavi-t-simple-get-goods-type.php', 'line' => __LINE__)); return '';
				}
			}
		}

		if ($result_goods_type !== '' && $standart === 'zhivotnye') {
			if ($this->get_feed_category_avito_name() === 'Кошки' || 
				$this->get_feed_category_avito_name() === 'Собаки') {
				$tag_name = 'Breed';
				$result_xml .= '<AdType>Продаю как заводчик</AdType>';
			} 
		}

		// для Велосипеды в разделе хобби GoodsType называется VehicleType
		if ($this->get_feed_category_avito_name() === 'Велосипеды') {$tag_name = 'VehicleType';}

		$result_xml .= new XFAVI_Get_Paired_Tag($tag_name, $result_goods_type);
		return $result_xml;
	}
}
?>