<?php if (!defined('ABSPATH')) {exit;}
/**
* Traits for variable products
*
* @author		Maxim Glazunov
* @link			https://icopydoc.ru/
* @since		1.6.0
*
* @return 		$result_xml (string)
*
* @depends		class:	XFAVI_Get_Paired_Tag
*				methods: add_skip_reason
*				functions: 
*/

trait XFAVI_T_Variable_Get_Title {
	public function get_title($tag_name = 'title', $result_xml = '') {
		$product = $this->product;
		$offer = $this->get_offer();

		$result_xml_name = $product->get_title(); // название товара
		$result_xml_name = apply_filters('xfavi_f_variable_tag_value_name', $result_xml_name, array('product' => $product, 'offer' => $offer), $this->get_feed_id());

		$result_xml = new XFAVI_Get_Paired_Tag($tag_name, htmlspecialchars($result_xml_name, ENT_NOQUOTES));

		$result_xml = apply_filters('xfavi_f_variable_tag_name', $result_xml, array('product' => $product, 'offer' => $offer), $this->get_feed_id());
		return $result_xml;	 
	}
}
?>